//
//  AuthRequestViewController.h
//  SPTwitterEngine
//
//  Created by Sam Page on 30/08/11.
//  Copyright 2011 Sam Page. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "OAuthConsumer.h"

// You need to enter a callback URL (preferably your own)
// in your App's page at dev.twitter.com, more details about
// this method can be found here http://infinite-sushi.com/2011/07/twitter-oauth-and-ios/
#define CALLBACK_URL @"yourwebsite.com/somefakecallbackpage"

@class AuthRequestViewController;

@protocol AuthRequestViewControllerDelegate <NSObject>
@required
- (void)authRequestDidReceiveRequestToken:(OAToken *)token;
@end

@interface AuthRequestViewController : UIViewController <UIWebViewDelegate> {

	id<AuthRequestViewControllerDelegate> delegate;
	UIWebView *authWebView;
	OAToken *receivedToken;
}

@property (nonatomic, assign) id<AuthRequestViewControllerDelegate> delegate;
@property (nonatomic, retain) IBOutlet UIWebView *authWebView;

- (void)loadAuthRequestURL:(NSURL *)url;

@end
