//
//  AuthRequestViewController.m
//  SPTwitterEngine
//
//  Created by Sam Page on 30/08/11.
//  Copyright 2011 Sam Page. All rights reserved.
//

#import "AuthRequestViewController.h"

@implementation AuthRequestViewController
@synthesize delegate;
@synthesize authWebView;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
		//
    }
    return self;
}

- (void)loadAuthRequestURL:(NSURL *)url {

	[authWebView loadRequest:[NSURLRequest requestWithURL:url]];
}

/* This is a neat little trick found here http://infinite-sushi.com/2011/07/twitter-oauth-and-ios/
 * as a way of bypassing lousy pin entry, bit hacky but works */
- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType {
	
	NSMutableString *callbackURL = [NSMutableString stringWithString:[[request URL] absoluteString]];
	NSString *substringURL = CALLBACK_URL;
	NSRange substringRange = [callbackURL rangeOfString:substringURL];

	if (substringRange.location != NSNotFound) {
		NSRange callbackRange = NSMakeRange(0, [callbackURL length]);
		[callbackURL replaceOccurrencesOfString: [NSString stringWithFormat:@"http://%@?oauth_token=", CALLBACK_URL]
								 withString: @""
									options: 0
									  range: callbackRange];
		callbackRange = NSMakeRange(0, [callbackURL length]);
		[callbackURL replaceOccurrencesOfString: @"&oauth_verifier"
									 withString: @""
										options: 0
										  range: callbackRange];
		NSArray *tokenData = [callbackURL componentsSeparatedByString: @"="];

		receivedToken = [[OAToken alloc] initWithKey:[tokenData objectAtIndex:0] secret:[tokenData objectAtIndex:1]];
		
		[delegate performSelector:@selector(authRequestDidReceiveRequestToken:) withObject:receivedToken];
		
		return false;
	}
	
	return true;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [self setAuthWebView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return YES;
}

- (void)webViewDidStartLoad:(UIWebView *)webView {
#ifdef DEBUG
	NSLog(@"Loading auth page");
#endif
}

- (void)webViewDidFinishLoad:(UIWebView *)webView {
#ifdef DEBUG
	NSLog(@"Finished loading auth page");
#endif
}

- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error {
#ifdef DEBUG
	NSLog(@"Error: %@", [error localizedDescription]);
#endif
}

- (void)dealloc {
    [authWebView release];
    [super dealloc];
}
@end
