//
//  Tweet.m
//  MapTest
//
//  Created by Sam Page on 24/08/11.
//  Copyright 2011 Sam Page. All rights reserved.
//

#import "Tweet.h"

@implementation Tweet
@synthesize text, username, realname, profileImageURL, time, latitude, longitude, coordinate, isGeotagged, client;

- (id)init {
	
	self = [super init];
    if (self) {
		isGeotagged = FALSE; // Set the initial value, will change if the tweet is geotagged.
	}
	return self;
}


#pragma mark - MKAnnotation methods
- (NSString *)title
{
	// return the user's name
    return realname;
}

- (NSString *)subtitle
{
	// Return the tweet text
    return text;
}

- (NSString *)description {
	
	NSString *desc = [NSString stringWithFormat:@"Username: %@\nStatus: %@", username, text];
	return desc;
}

- (void)dealloc {
	
	[text release];
	[realname release];
	[username release];
	[profileImageURL release];
	[time release];
	[client release];
	[super dealloc];
}

@end
