//
//  TwitterAuthEngine.h
//  SPTwitterEngine
//
//  Created by Sam Page on 30/08/11.
//  Copyright 2011 Sam Page. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "AuthRequestViewController.h"
#import "OAuthConsumer.h"

// Twitter app oauth keys
// You need to create a Twitter developer account at 
// dev.twitter.com, then grab your key/secret from 
// your apps details page.
#define OAuthConsumerKey @"INSERT YOUR TWITTER APP CONSUMER KEY"
#define OAuthConsumerSecret @"INSERT YOUR TWITTER APP CONSUMER SECRET"

@protocol TwitterAuthEngineDelegate <NSObject>
@required
- (void)twitterAuthEngineDidReceiveAccessToken:(OAToken *)accessToken;
- (void)twitterAuthEngineReceivedRequestURL:(NSURL *)requestURL;
@end

@interface TwitterAuthEngine : NSObject <AuthRequestViewControllerDelegate> {
	
	OAMutableURLRequest *request;
	NSURLConnection *connection;
	OAConsumer *consumer;
	OAToken *requestToken;
	OAToken *accessToken;
}

@property (nonatomic, retain) id delegate;
@property (nonatomic, retain) OAToken *accessToken;

- (id)initWithAccessTokenData:(NSString *)key andSecret:(NSString *)secret;
- (void)getUnauthorizedRequestToken;

@end
