//
//  TwitterPostEngine.m
//  SPTwitterEngine
//
//  Created by Sam Page on 30/08/11.
//  Copyright 2011 Sam Page. All rights reserved.
//

#import "TwitterPostEngine.h"
#import "TwitterAuthEngine.h"

@implementation TwitterPostEngine

- (id)initWithAccessToken:(OAToken *)_accessToken
{
    self = [super init];
    if (self) {
		accessToken = _accessToken;
		consumer = [[OAConsumer alloc] initWithKey:OAuthConsumerKey
											secret:OAuthConsumerSecret];
    }
    
    return self;
}

- (void)postTweet:(NSString *)tweet {
	
	NSURL *url = [NSURL URLWithString:@"http://api.twitter.com/1/statuses/update.json"];
	
    request = [[OAMutableURLRequest alloc] initWithURL:url
											  consumer:consumer
												 token:accessToken   // we don't have a Token yet
												 realm:nil   // our service provider doesn't specify a realm
									 signatureProvider:nil]; // use the default method, HMAC-SHA1
	
    [request setHTTPMethod:@"POST"];
	
	NSString *melbourneCoords = @"&lat=-37.808902&long=144.962282"; // Hardcoded for RMIT
	
	[request setHTTPBodyWithString:[NSString stringWithFormat:@"status=%@%@&display_coordinates=true", tweet, melbourneCoords]];
	
	NSLog(@"%@", [NSString stringWithFormat:@"status=%@%@&display_coordinates=true", tweet, melbourneCoords]);
	
    OADataFetcher *fetcher = [[OADataFetcher alloc] init];
	
    [fetcher fetchDataWithRequest:request
                         delegate:self
                didFinishSelector:@selector(statusUpdate:didFinishWithData:)
                  didFailSelector:@selector(statusUpdate:didFailWithError:)];
	
	[fetcher release];
}

- (void)statusUpdate:(OAServiceTicket *)statusTicket didFinishWithData:(NSData *)data {
	
	NSString* aStr;
	aStr = [[NSString alloc] initWithData:data encoding:NSASCIIStringEncoding];
	NSLog(@"%@", aStr);
	[aStr release];
}

- (void)statusUpdate:(OAServiceTicket *)statusTicket didFailWithError:(NSError *)error {
	
	NSLog(@"Status update failed: %@", error);
}

@end
