//
//  TwitterStreamEngine.h
//  SPTwitterEngine
//
//  Created by Sam Page on 30/08/11.
//  Copyright 2011 Sam Page. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "OAuthConsumer.h"
#import "SBJson.h"
#import "Tweet.h"

#define USER_STREAM [NSURL URLWithString:@"https://userstream.twitter.com/2/user.json"]
#define PUBLIC_STREAM [NSURL URLWithString:@"https://stream.twitter.com/1/statuses/filter.json"]
#define SAMPLE_STREAM [NSURL URLWithString:@"https://stream.twitter.com/1/statuses/sample.json"]
#define WORLDWIDE_LOCATION_FILTER @"locations=-180,-85,180,85"

@protocol TwitterStreamEngineDelegate <NSObject>
@optional
- (void)twitterStreamEngineDidReceiveTweet:(Tweet *)_tweet;
- (void)twitterStreamEngineDidFailWithError:(NSError *)_error;
- (void)twitterStreamEngineDidCloseConnection;
@end

@interface TwitterStreamEngine : NSObject <SBJsonStreamParserDelegate> {
	
	id delegate;
	SBJsonStreamParser *streamParser;
	OAMutableURLRequest *request;
	OAStreamDataFetcher *fetcher;
	OAToken *accessToken;
	OAConsumer *consumer;
	NSURL *streamURL;
	NSString *filter;
	BOOL isConnected;
}

- (id)initWithAccessToken:(OAToken *)_accessToken 
			 andStreamURL:(NSURL *)_streamURL 
				andFilter:(NSString *)_filter 
			  andDelegate:(id)_delegate;

- (void)startTweetStream;
- (void)stopTweetStream;

@property (nonatomic) BOOL isConnected;

@end
