//
//  OAStreamDataFetcher.m
//  SPTwitterEngine
//
//  Created by Sam Page on 30/08/11.
//  Copyright 2011 Sam Page. All rights reserved.
//

#import "OAStreamDataFetcher.h"

@implementation OAStreamDataFetcher

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	OAServiceTicket *ticket = [[OAServiceTicket alloc] initWithRequest:request
															  response:response
																  data:responseData
															didSucceed:[(NSHTTPURLResponse *)response statusCode] < 400];
	//[responseData appendData:data];
	[delegate performSelector:didReceiveSelector withObject:ticket withObject:data];
	[ticket release];
}

- (void)cancelStreamConnection {
	[connection cancel];
}

- (void)fetchDataWithRequest:(OAMutableURLRequest *)aRequest 
					delegate:(id)aDelegate 
	  didReceiveDataSelector:(SEL)receivedSelector 
		   didFinishSelector:(SEL)finishSelector 
			 didFailSelector:(SEL)failSelector {
	
	[request release];
	request = [aRequest retain];
    delegate = aDelegate;
	didReceiveSelector = receivedSelector;
    didFinishSelector = finishSelector;
    didFailSelector = failSelector;
    
    [request prepare];
	
	connection = [[NSURLConnection alloc] initWithRequest:aRequest delegate:self];
}

- (void)dealloc {
	[connection release];
	[response release];
	[responseData release];
	[request release];
	[super dealloc];
}

@end
