//
//  SPTwitterEngineDemoAppDelegate.m
//  SPTwitterEngineDemo
//
//  Created by Sam Page on 12/10/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SPTwitterEngineDemoAppDelegate.h"

@implementation SPTwitterEngineDemoAppDelegate

@synthesize window = _window;
@synthesize navigationController = _navigationController;
@synthesize twitterAuthEngine;
@synthesize authRequestViewController;
@synthesize OAuthToken;

#pragma mark - TwitterAuthEngineDelegate methods

- (void)twitterAuthEngineReceivedRequestURL:(NSURL *)requestURL {

	authRequestViewController = [[AuthRequestViewController alloc] initWithNibName:@"AuthRequestViewController"
																			bundle:nil];
	
	[authRequestViewController setDelegate:twitterAuthEngine];
	
	[self.window.rootViewController presentModalViewController:authRequestViewController animated:YES];
	
	[authRequestViewController loadAuthRequestURL:requestURL];
	
	[authRequestViewController release];
}

- (void)twitterAuthEngineDidReceiveAccessToken:(OAToken *)accessToken {
	
	[self setOAuthToken:accessToken];
	
	[self.window.rootViewController dismissModalViewControllerAnimated:YES];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
	// Override point for customization after application launch.
	// Add the tab bar controller's current view as a subview of the window
	self.window.rootViewController = self.navigationController;
	[self.window makeKeyAndVisible];
	
	twitterAuthEngine = [[TwitterAuthEngine alloc] init];
	[twitterAuthEngine setDelegate:self];
	[twitterAuthEngine getUnauthorizedRequestToken];
	
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
	/*
	 Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
	 Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
	 */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
	/*
	 Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
	 If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
	 */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
	/*
	 Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
	 */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
	/*
	 Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
	 */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
	/*
	 Called when the application is about to terminate.
	 Save data if appropriate.
	 See also applicationDidEnterBackground:.
	 */
}

- (void)dealloc
{
	[_window release];
	[_navigationController release];
	[twitterAuthEngine release];
	[authRequestViewController release];
	[OAuthToken release];
    [super dealloc];
}

/*
// Optional UITabBarControllerDelegate method.
- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController
{
}
*/

/*
// Optional UITabBarControllerDelegate method.
- (void)tabBarController:(UITabBarController *)tabBarController didEndCustomizingViewControllers:(NSArray *)viewControllers changed:(BOOL)changed
{
}
*/

@end
